// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#include <qapplication.h>
#include <qwindowsstyle.h>
#include <qdir.h>
#include <stdio.h>
#include "application.h"
#include "xbschglobal.h"


class SCmdlineOption{
public:
	SCmdlineOption();
	string openFileName;
	string configFileName;
	void setupOption(QApplication& a);
};

SCmdlineOption::SCmdlineOption()
{
	openFileName	="";
	configFileName	="";
}

void SCmdlineOption::setupOption(QApplication& a)
{
	int i;
	string var="";
	string val="";
	for(i=1;i<a.argc();i++){
		val=string(a.argv()[i]);
		if(val[0]=='-'){
			var=val;
		}else{
			if(var.length()==0){
				openFileName = val;
			}else if(var=="-conf"){
				configFileName = val;
			}
			var = "";
		}
	}
}


int main( int argc, char ** argv )
{
	//QApplication::setStyle(new QWindowsStyle());
	QApplication::setStyle("windows");
	QApplication a( argc, argv );

	SCmdlineOption cmdoption;
	cmdoption.setupOption(a);


	g_strCfgFileName = cmdoption.configFileName;
	
	if(g_strCfgFileName.length()==0){
		//ޥɥ饤Ǥλ̵꤬äΥե졼ե̾
#ifdef _WINDOWS
		//WindowsǤǤϡȥǥ쥯ȥ qbsch.cfg
		g_strCfgFileName = string(QDir::currentDirPath().local8Bit());
		g_strCfgFileName = g_strCfgFileName + "/qbsch.cfg";
#else
		//LINUXǤǤϡۡǥ쥯ȥ .qbschrc
		g_strCfgFileName = string(QDir::homeDirPath().local8Bit());
		g_strCfgFileName = g_strCfgFileName + "/.qbschrc"; 
#endif
	}

	
	
	g_cfg.load(g_strCfgFileName.c_str());
	g_ReadLibrary();



	ApplicationWindow * mw = new ApplicationWindow();

	mw->show();

	if(cmdoption.openFileName.length()>0){
		mw->load(QString::fromLocal8Bit(cmdoption.openFileName.c_str()));
	}
	
	a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
	
	int result = a.exec();
//	g_cfg.dump();
	g_cfg.save(g_strCfgFileName.c_str());

	g_FreeLibrary();

	

	return result;
}
